function[H,F,G,W,E,K]=matrixCompactForm2011(A,B,Q,P,N,Xc, u_min, u_max)

n = size(A,1); %number of states
m = size(B,2); %number of inputs

%% Generate A_hat
for i = 1:N+1
   A_hat(1+n*(i-1):1+n*(i-1)+(n-1),1:n) = A^(i-1);
end

%% Generate B_hat
for i=1:N
    for j = 1:N+1
         if j == 1
            B_hat(1:n,1:m) = zeros(n,m);
         end
         if j-i-1<0
            B_hat(1+n*(j-1):1+n*(j-1)+(n-1),1+m*(i-1):1+m*(i-1)+(m-1)) = zeros(n,m);
         else
            B_hat(1+n*(j-1):1+n*(j-1)+(n-1),1+m*(i-1):1+m*(i-1)+(m-1)) = A^(j-1-(i-1)-1)*B; 
         end     
    end
end

%% Calculate feasible set after fault

I_hat = kron(eye(N+1),Xc(:,1:n));
J_hat = repmat(Xc(:,1+n),N+1,1);

K = I_hat*A_hat;
L = I_hat*B_hat;

%% Generate Q_hat and P_hat
Q_hat = repmat(Q,1,N+1);
P_hat = repmat(P,1,N);


%% Generate H and F. Matrices that are used in J=-Qx+Pu=Hu-Fx0 linear cost function.
H = P_hat-Q_hat*B_hat;
F = Q_hat*A_hat;  

%% Generate constraint matrices (G,W,E) used in compact notation for model constraints.  G*u <= W+E*x_0

G = [  eye(m*N);
     -eye(m*N);
     L];
 
 W = [ repmat(u_max, N, 1);
      repmat(-u_min, N, 1);
      J_hat];

 E = [  zeros(2*N*m,n);
       -K];
   


